#import <DefinedConstants.h>
#import <SFDatabase.h>
#import "SFVariable.h"
#import "SFSystemProcedure.h"
#import "SFCurrentDateFunction.h"

static id instance = nil;					/* Id of the instance of the Class (one only) */
static BOOL instanceInitialized = NO;		/* Flag to track initialization of the instance */

@implementation SFCurrentDateFunction : SFSystemFunction

+ alloc
{
	if (instance == nil)
		instance = NSAllocateObject([self  class],0,NULL);
	return (instance);
}

- initFor: (id) sender
{
	if (instanceInitialized)
		return (instance);
	[super  initFor:sender];
	returnVariable = [[SFVariable  alloc]  initName:@"" type:DATAFIELD];
	[returnVariable  setDataType:DATE];
/*
**	Initialize rest of variables
*/
	instanceInitialized = YES;
	return self;
}

- (int) returnType
{
	return (DATE);
}

- (NSArray *) parameterList
{
	return nil;
}

- (NSString *) descriptionForFunction: (NSString *) name
{
	return (@"CurrentDate function returns the current date in YYYYMMDD format. "
		    @"It takes no parameters.");
}

- (NSString *) functionName
{
	return (@"CurrentDate");
}

- execute: (NSArray *) parmList
{
	NSString *date, *time;
/*
**	Execute function
*/
	[super  execute:nil];
	[database  getCurrentDate:&date time:&time];
	[returnVariable  setValue:date];
	return (returnVariable);
}

- (void) dealloc
{
	instance = nil;
	instanceInitialized = NO;
	[super  dealloc];
}

- initWithCoder: (NSCoder *) aDecoder
{
	instance = self;
	instanceInitialized = YES;
	return self;
}

@end