#import <DefinedConstants.h>
#import <SFDatabase.h>
#import "SFVariable.h"
#import "SFSystemProcedure.h"
#import "SFCurrentTimeFunction.h"

static id instance = nil;					/* Id of the instance of the Class (one only) */
static BOOL instanceInitialized = NO;		/* Flag to track initialization of the instance */

@implementation SFCurrentTimeFunction : SFSystemFunction

+ alloc
{
	if (instance == nil)
		instance = NSAllocateObject([self  class],0,NULL);
	return (instance);
}

- initFor: (id) sender
{
	if (instanceInitialized)
		return (instance);
	self = [super  initFor:sender];
	returnVariable = [[SFVariable  alloc]  initName:@"" type:DATAFIELD];
	[returnVariable  setDataType:TIME];
/*
**	Initialize rest of variables
*/
	instanceInitialized = YES;
	return self;
}

- (int) returnType
{
	return (TIME);
}

- (NSArray *) parameterList
{
	return nil;
}

- (NSString *) descriptionForFunction: (NSString *) name
{
	return (@"CurrentTime function returns the current time in HHMMSS format. "
		    @"It takes no parameters.");
}

- (NSString *) functionName
{
	return (@"CurrentTime");
}

- execute: (NSArray *) parmList
{
	NSString *date, *time;
/*
**	Execute function
*/
	[super  execute:nil];
	[database  getCurrentDate:&date time:&time];
	[returnVariable  setValue:time];
	return (returnVariable);
}

- (void) dealloc
{
	instance = nil;
	instanceInitialized = NO;
	[super  dealloc];
}

- initWithCoder: (NSCoder *) aDecoder
{
//	[super  initWithCoder:aDecoder];
	instance = self;
	instanceInitialized = YES;
	return self;
}

@end