#import <libtools.h>
#import <DefinedConstants.h>
#import <SFDatabase.h>
#import <SFDynamicString.h>
#import "SFVariable.h"
#import "SFSystemProcedure.h"
#import "SFDocumentNameFunction.h"
#import "SFTransactionPane.h"

@implementation SFDocumentNameFunction : SFSystemFunction

- initFor: (id) sender
{
	[super  initFor:sender];
	returnVariable = [[SFVariable  alloc]  initName:@"" type:DATAFIELD];
	[returnVariable  setDataType:TEXT];
/*
**	Initialize rest of variables
*/
	pane = nil;
	return self;
}

- (int) returnType
{
	return (TEXT);
}

- (NSArray *) parameterList
{
	return nil;
}

- (NSString *) descriptionForFunction: (NSString *) name
{
	return (@"DocumentName function returns the name of currently used Document, "
		    @"and should be used only in Transaction procedures. It takes no parameters.");
}

- (NSString *) functionName
{
	return (@"DocumentName");
}

- (void) setPane: (id) object
{
	if ([object  respondsToSelector:@selector(docName)])
		pane = object;
	else
		pane = nil;
}

- execute: (NSArray *) parmList
{
	NSString *docName;
	[super  execute:nil];
	docName = [pane  docName];
	[returnVariable  setValue:docName];
	return (returnVariable);
}

@end