/*
**	Add-on function for STEPforward flowcharts.
**	Release 2.0
**	Copyright (c) 1998, Phoenix Data Trend.  All rights reserved.
**
**	You can use this source code as a prototype to develop your
**	own precompiled functions for inclusion into the STEPforward
**	function inventory.
**
**	Note, however, that Phoenix Data Trend does not provide a
**	warranty or support for the functions developed by the user,
**	nor is Phoenix Data Trend liable for any indirect, special,
**	incidental or consequential damages that the use of such
**	functions may cause.
*/

#import "SFSummaryFunctions.h"

@interface SFSummaryRangeFunctions : SFSummaryFunctions
{
	NSString *lastStartingDate;			/* Last used starting date */
}

- initFor: (id) sender;
- (void) setFunctionName: (NSString *) name;
- (NSString *) descriptionForFunction: (NSString *) name;
- (NSArray *) functionNameList;
- execute: (NSArray *) parmList;
- (void) extractDataForList: (NSString *) listName
	glPrefix: (NSString *) prefix
	subledgerNumber: (int) slNumber
	startingDate: (NSString *) startingDate
	endingDate: (NSString *) endingDate
	systemState: (short) state
	simulatePosting: (BOOL) sPost;
- (void) simulatePostingBetweenPeriod: (short) startingFiscalPeriod
	and: (short) endingFiscalPeriod
	subledgerNumber: (int) slNumber
	startingDate: (NSString *) startingDate
	endingDate: (NSString *) endingDate;
- (void) prepareAllDataForList: (NSString *) listName
	glPrefix: (NSString *) prefix
	subledger: (NSString *) subledger
	documentType: (char) docType
	documentClass: (char) restatement
	startingDate: (NSString *) startingDate
	endingDate: (NSString *) endingDate
	systemState: (short) state
	simulatePosting: (BOOL) sPost;
- (void) saveList: (NSString *) listName
	glPrefix: (NSString *) prefix
	startingDate: (NSString *) startingDate
	endingDate: (NSString *) endingDate
	systemState: (short) state
	simulatePosting: (BOOL) sPost;
- (double) creditAmountForList: (NSString *) listName
	glPrefix: (NSString *) prefix
	subledger: (NSString *) subledger
	documentType: (char) docType
	documentClass: (char) restatement
	startingDate: (NSString *) startingDate
	endingDate: (NSString *) endingDate
	systemState: (short) state
	simulatePosting: (BOOL) sPost;
- (double) debitAmountForList: (NSString *) listName
	glPrefix: (NSString *) prefix
	subledger: (NSString *) subledger
	documentType: (char) docType
	documentClass: (char) restatement
	startingDate: (NSString *) startingDate
	endingDate: (NSString *) endingDate
	systemState: (short) state
	simulatePosting: (BOOL) sPost;
- (void) dealloc;

@end