#import <libtools.h>
#import <DefinedConstants.h>
#import "SFVariable.h"
#import "SFSystemProcedure.h"
#import "SFTextToDate.h"
#import "SFParameterData.h"
#import "NSArrayAdditionalMethods.h"

static id instance = nil;						/* Id of the instance of the Class (one only) */
static BOOL instanceInitialized = NO;		/* Flag to track initialization of the instance */

@implementation SFTextToDate : SFSystemFunction

+ alloc
{
	if (instance == nil)
		instance = NSAllocateObject([self  class],0,NULL);
	return (instance);
}

- initFor: (id) sender
{
	SFParameterData *parameter;
	if (instanceInitialized)
		return (instance);
	[super  initFor:sender];
/*
**	Create Storage for parameter data and fill it in
*/
	parameterList = [[NSMutableArray  alloc]  initWithCapacity:0];
	parameter = [[SFParameterData  alloc]
						initWithName:@"Text"
						dataType:TEXT
						displayedDataType:TEXT
						ioFlag:INPUT
						runTime:YES
						isSwitchDisplayed:YES];
	[parameterList  addObjectWithoutRetaining:parameter];
	parameter = [[SFParameterData  alloc]
						initWithName:@"Date"
						dataType:DATE
						displayedDataType:DATE
						ioFlag:OUTPUT
						runTime:YES
						isSwitchDisplayed:NO];
	[parameterList  addObjectWithoutRetaining:parameter];
/*
**	Initialize rest of variables
*/
	instanceInitialized = YES;
	return self;
}

- (int) returnType
{
	return (UNKNOWN);
}

- (NSString *) descriptionForFunction: (NSString *) name
{
	return (@"TextToDate function takes the original text string in CCYYMMDD format "
		    @"of TEXT type and converts it to the string of DATE type. The contents of the "
		    @"output string remains the same."
		    @"\n\nThe function takes the following input/output parameters:\n"
		    @"<Text> - original string of TEXT type\n"
		    @"<Date> - converted string of DATE type\n");
}

- (NSString *) functionName
{
	return (@"TextToDate");
}

- execute: (NSArray *) parmList
{
	id variable;
	NSString *text;
	[super  execute:nil];
	text = [[parmList  objectAtIndex:0]  value];
	variable = [parmList  objectAtIndex:1];
	[variable  setValue:text];
	return nil;
}

- (void) dealloc
{
	instance = nil;
	instanceInitialized = NO;
	[super  dealloc];
}

- initWithCoder: (NSCoder *) aDecoder
{
//	[super  initWithCoder:aDecoder];
	instance = self;
	instanceInitialized = YES;
	return self;
}

@end