#import <AppKit/AppKit.h>
#import <SFDataWrapper.h>
#import <SFQuestion.h>
/*
**	Defined constants used in CornerStone modules
*/
#define	MAXSLEDG		    8		/* Max number of characters in Subsidiary Master name */
#define	MAXSDOC		    8		/* Max number of characters in Source Document name */
#define	MAXTEMPL		    8		/* Max number of characters in Transaction Template name */
#define	MAXACCTLIST	  20		/* Max number of characters in Account List name */
#define	MAXACCTGRP	  20		/* Max number of characters in Account Group name */
#define	MAXFUNCT		  20		/* Max number of chars in User Function name */
#define	MAXPRTEMPL	  20		/* Max number of chars in Print Template name */
#define	MAXBUNDLE		  20		/* Max number of chars in Suggested Distribution bundle name */
#define	MAXDESCR		  40		/* Max number of chars in Transaction Template description */
#define	MAXCODE		  10		/* Max number of characters in Account Component code */
#define	MAXTEXT   	   	  60		/* Max number of characters in Account Component description */
#define	MAXNAME		  30		/* Max number of characters in database table name (Sybase) */
#define	MAXTABL		  10		/* Max number of Account levels, including GL Number */
#define	MAXLENGTH		255		/* Max number of characters in varchar-type variable (Sybase) */
#define	MAXLEVEL		  10		/* Maximum number of range levels */
/*
**	Screen layout constants
*/
#define	BACKGROUND       -100		/* Tag assigned to the view that can be encroached on by Bar */
#define	CHANGEFIELD       -101		/* Tag assigned to the Change field */
#define	OFF_WHITE	      0.834		/* Off-white color */
#define	NSButtonBorder		NSGrooveBorder
/*
**	Run Loop termination constants
*/
#define	SFRunStoppedResponse		0		/* Custom stop flag */
/*
**	Syntax check timeout
*/
#define	TIMEOUT			1.0		/* Screen refreshes in 1 sec */
/*
**	GL Chart Builder constants
*/
#define	MAXHDESCR		67		/* Maximum size of Header */
#define	ENTER		 	 1		/* Enter button pressed */
#define	CANCEL			  0		/* Cancel button pressed */
/*
**	Start-up preference flags
*/
#define	START_NEW					0
#define	START_LAST_OPENED			1
#define	LET_USER_SELECT			2
#define	START_REVIEW				START_NEW

/*
**	Data type constants
*/
#define	ALPHA_TYPE		@"Text"			/* Text data type */
#define	PWD_TYPE		@"Password"		/* Password data type */
#define	DATE_TYPE		@"Date"			/* Date data type */
#define	TIME_TYPE		@"Time"			/* Time data type */
#define	MONEY_TYPE	@"Money"		/* Money data type */
#define	INTEGER_TYPE	@"Integer"		/* Integer data type */
#define	FLOAT_TYPE		@"Float"			/* Floating data type */
#define	GLPFX_TYPE		@"GL Prefix"		/* GL Prefix type */
#define	GLNUM_TYPE		@"GL Account"	/* GL Number type */
#define	SLNUM_TYPE		@"Subledger N"	/* SL Number type */
#define	GLLIST_TYPE		@"Account List"	/* GL Account list type */
#define	PERIOD_TYPE	@"Period"		/* Fiscal period type */
#define	SEARCH_TYPE	@"Search key"	/* Formatted search key */
#define	FILENAME_TYPE	@"File name"		/* File name type */
#define	IMAGE_TYPE		@"Image"			/* Image type */
#define	NOTE_TYPE		@"Note"			/* Note type */
#define	SWITCH_TYPE	@"Switch"		/* Switch type */
/*
**	Data Types
*/
#if defined(PASSWORD)
	#undef PASSWORD
#endif
#define	EMPTY			  -3			/* Empty variable */
#define	INVALID			  -2			/* Invalid variable */
#define	UNKNOWN		  -1			/* Unknown type (no validation) */
#define	DATE			   0			/* Date type */
#define	TEXT			   1			/* Alphanumeric type */
#define	INTEGER			   2			/* Integer type */
#define	FLOAT			   3			/* Floating-point type */
#define	MONEY			   4			/* Money type */
#define	GL				   5			/* Prefix/GL type */
#define	LOGICAL			   6			/* Logical type */
#define	ACCPERIOD		   7			/* Accounting Period type */
#define	GLACCLIST		   8			/* GL Account list */
#define	GLPREFIX		   9			/* GL Prefix */
#define	GLNUMBER		 10			/* GL Number */
#define	TIME			 11			/* Time type */
#define	SHORT			 12			/* Short (2-byte) integer type */
#define	TINY			 13			/* Tiny integer (unsigned char) type */
#define	SEARCHKEY		 14			/* "Search key" special type */
#define	GLACCGROUP	 15			/* GL Account group */
#define	FILENAME		 16			/* File name type */
#define	BINARYOBJECT	 17			/* BLOB type */
#define	NOTE			 18			/* Note type */
#define	IMAGE			 19			/* Image type */
#define	SLNUMBER		 20			/* Subledger number */
#define	DATETIME		 21			/* Date with Time format */
#define	NSOBJECT		 22			/* Archived NSObject type */
#define	PASSWORD		 23			/* Password type */
/*
**	Fiscal Periof constants (calibration)
*/
#define	QUARTERLY			0		/* Quarter period tag */
#define	MONTHLY			1		/* Month period tag */
#define	HALFMONTHLY		2		/* Half-month period tag */
#define	FOURWEEKLY		3		/* Four Weeks period tag */
#define	TWOWEEKLY			4		/* Two Weeks period tag */
#define	WEEKLY				5		/* Week period tag */
#define	DAILY				6		/* Day period tag */
#define	OTHER				7		/* Other (user-defined) period tag */
/*
**	Special extentions to Data Types
*/
#define	VARIABLE_NAME			94		/* Variable name */
#define	TABLE_NAME				95		/* Table name */
#define	SYSTEM_NAME			96		/* System field name */
#define	USER_NAME				97		/* User field name */
#define	GLPREFIX_OR_STAR		98		/* GL Prefix or asterisk */
#define	GLNUMBER_OR_STAR		99		/* GL Number or asterisk */
/*
**	Document style flags
*/
#define	JOURNAL_ENTRY		 0			/* Journal Entry */
#define	FIXED_HEADER		 1			/* Document with fixed Header line */
/*
**	Open cell tags
*/
#define	DONT_ENABLE_CELL		 0		/* Open cell cannot be enabled */
#define	CAN_ENABLE_CELL		 1		/* Open cell can be enabled */
/*
**	Extent of database copying
*/
#define	STRUCTURE_ONLY		0		/* Only tables and accounts */
#define	ALL_CONTENT			1		/* Tables and their contents */
/*
**	Cell tags for Procedures column
*/
#define	PROCHEADER		0			/* Section header */
#define	PROCINIT			1			/* Initialization procedure */
#define	PROCLOAD			2			/* Loading procedure */
#define	PROCSAVE			3			/* Saving procedure */
#define	PROCPOST			4			/* Posting procedure */
#define	PROCDELETE			5			/* Deleting procedure */
#define	PROCGENERAL		6			/* General procedure */
#define	PROCFIELD			7			/* Field-driven procedure */
#define	PROCLINE			8			/* Line entry procedure */
#define	PROCHEQUE			9			/* Check generation procedure */
/*
**	Cell tags for Transaction fields column
*/
#define	GENVAR				  0			/* Temporary variable cell tag (generic) */
#define	TEMPVAR			  1			/* Temporary variable cell tag (new) */
#define	CURMAST			  2			/* Current master cell tag */
#define	CURDATE			  3			/* Current date cell tag */
#define	CURTIME				  4			/* Current time cell tag */
#define	LOGVAR			         22			/* Logical cell tag */
#define	EMPTYVAR		         23			/* Empty cell tag */
#define	GENPAR				  5			/* Temporary parameter cell tag (generic) */
#define	TEMPPAR			  6			/* Temporary parameter cell tag (new) */
#define	EXTRAFLD			  7			/* Extra field cell tag */
#define	FUNCTNAME			  8			/* Function name cell tag */
#define	GENDFIELD			  9			/* Dynamic field cell tag (generic) */
#define	GENSFIELD		         10			/* Static field cell tag (generic) */
#define	TEMPDFIELD		         11			/* Dynamic field cell tag (new) */
#define	TEMPSFIELD		         12			/* Static field cell tag (new) */
#define	DYNHEADER		         13			/* Dynamic header field cell tag */
#define	STATHEADER	 	         14			/* Static header field cell tag */
#define	SYSHEADER		         15			/* System header field cell tag */
#define	PAGEFIELD		         16			/* Page field cell tag */
#define	VARHEADER		         17			/* Variable header field cell tag */
#define	PARHEADER		         18			/* Variable header field cell tag */
#define	FLDHEADER		         19			/* Field header cell tag */
#define	DSPLHEADER	  	         20			/* Display-only field cell tag */
#define	CONSTHEADER	         21			/* Constant header field cell tag */
#define	FLDVAR			         20			/* Master field cell tag */
#define	SPECIALHEADER	         24			/* Special field header cell tag */
#define	SYSTEMVAR	  	         25			/* System field cell tag */
#define	ARRAYHEADER	         26			/* Array header field cell tag */
#define	ARRAYVAR	  	         27			/* Array field cell tag */
/*
**	Special constants for the pasteboard
*/
#define	ANYTYPE			  0			/* Variable of any type accepted */
#define	TFIELD				  1			/* Regular transaction field */
#define	GVAR				  2			/* Temporary variable (generic) */
#define	TVAR				  3			/* Temporary variable (existing) */
#define	CMAST				  4			/* Current master */
#define	CDATE				  5			/* Current date */
#define	CTIME				  6			/* Current time */
#define	MNAME				  7			/* Master name */
#define	MFIELD				  8			/* Master field */
#define	OPERATOR			  9			/* Operator */
#define	KEYWORD			10			/* Keyword (IF,ELSE) */
#define	GPAR				11			/* Temporary parameter (generic) */
#define	TPAR				12			/* Temporary parameter (existing) */
#define	FNAME				13			/* Function name field */
#define	ALISTNAME			14			/* Account List name field */
#define	AGROUPNAME		15			/* Account Group name field */
#define	PTNAME				16			/* Print Template name field */
#define	STNAME				17			/* Name of temporary DB Storage */
#define	TXNAME				18			/* Name of TX table ("Common" or Extra) */
#define	LVAR				19			/* Logical constant (YES or NO) */
#define	EVAR				20			/* Empty constant */
#define	FMDIVIDER			255			/* Divider between Field and Master */
/*
**	Special constants for the pasteboard
*/
#define	CONDITION			0			/* Conditional statement */
#define	CALCULATION		1			/* Calculation statement */
/*
**	Conversion factors for page units
*/
#define	REG_TO_CM		1.0583333		/* Convert to NX_UnitCentimeter */
#define	CM_TO_REG		0.9448819		/* Convert from NX_UnitCentimeter */
/*
**	Operator button tags
*/
#define	OP_NONE			        -1		/* No operation (single operand) */
#define	OP_PLUS				0		/* Plus */
#define	OP_MINUS				1		/* Minus */
#define	OP_MULTIPLY			2		/* Multiply */
#define	OP_DIVIDE				3		/* Divide */
#define	OP_EQUAL				4		/* Equal */
#define	OP_GREATER				5		/* Greater */
#define	OP_GREATEREQ			6		/* Greater or Equal */
#define	OP_LESS				7		/* Less */
#define	OP_LESSEQ				8		/* Less or Equal */
#define	OP_EQUALEQ			9		/* Equal Equal */
#define	OP_NOTEQUAL		       10		/* Not Equal */
#define	OP_LEFTBRACE		       11		/* Left brace */
#define	OP_RIGHTBRACE		       12		/* Right brace */
#define	OP_LEFTBRACKET	       13		/* Left bracket */
#define	OP_RIGHTBRACKET	       14		/* Right bracket */
#define	OP_LEFTPARENTH	       15		/* Left parenthesis */
#define	OP_RIGHTPARENTH	       16		/* Right parenthesis */
#define	OP_SEMICOLON		       17		/* Semicolon */
#define	OP_AND				       18		/* AND */
#define	OP_OR				       19		/* OR */
/*
**	Search Criteria constants
*/
#define	DATA				    0			/* Element contains the Field */
#define	FORMATDIVIDER		    0xFF		/* Divider between default formats */

#define	EQUALS				    0		/* Equality comparison operator (=) */
#define	GREATER			    1		/* Greater-than comparison operator (>) */
#define	LESS				    2		/* Less-than comparison operator (<) */
#define	GREATEROREQUAL	    3		/* Greater-than-or-equal-to comparison operator (>=) */
#define	LESSOREQUAL		    4		/* Less-than-or-equal-to comparison operator (<=) */
#define	NOTEQUALS			    5		/* Non-equality comparison operator (!=) */
#define	BETWEEN			    6		/* "Between" comparison operator (BETWEEN) */
#define	BETWEEN_AND		    7		/* Part 2 of "Between" comparison operator (AND) */
#define	LIKE					    8		/* "Like" comparison operator (LIKE) */
#define	NOTLIKE				    9		/* "Not like" comparison operator (NOT LIKE) */
#define	RUNTIME				  10		/* "Run-time" special operator */
#define	ACCTLIST			  11		/* "List" special operator */
#define	SEARCHSTR			  12		/* "Search key" special operator */
/*
**	Sort Order constants
*/
#define	ASC					0		/* Ascending sorting order */
#define	DESC				1		/* Descending sorting order */
/*
**	Rectangle side codes
*/
#define	TOPSIDE				0		/* Top */
#define	BOTTOMSIDE			1		/* Bottom */
#define	LEFTSIDE			2		/* Left */
#define	RIGHTSIDE			3		/* Right */
/*
**	Connection style codes
*/
#define	HV					0		/* Horiziontal - vertical */
#define	VH					1		/* Vertical - horiziontal */
/*
**	Terminator codes
*/
#define	START			0			/* Start box */
#define	FINISH			1			/* Finish box */
#define	HUB				2			/* Hub box */
#define	TERMINATOR		3			/* Terminator box */
/*
**	Transaction type codes
*/
#define	REGULAR_TX		0			/* Regular transaction */
#define	PAYMENT_TX	1			/* Discount transaction */
#define	DISCOUNT_TX	2			/* Discount transaction */
#define	BANK_TX		3			/* Bank transaction */
/*
**	Schedule types
*/
#define	REPORT			0			/* Report schedule */
#define	PROCESS		1			/* Process schedule */
/*
**	Statement types
*/
#define	NO_STATEMENT		-1			/* Non-executable statement */
#define	PARM_STM			0			/* Parameter statement */
#define	CALC_STM			1			/* Calculation statement */
#define	COND_STM			2			/* Conditional statement */
#define	DB_STM				3			/* Database statement */
#define	FUNCT_STM			4			/* Function statement */
#define	NEXTROW_STM		5			/* Next Row Conditional statement */
#define	HUB_STM			6			/* Hub statement */
#define	RET_STM			7			/* Return statement */
#define	START_STM			8			/* Start statement */
#define	FINISH_STM			9			/* Finish statement */
#define	ALERT_STM			10			/* Alert message statement */
#define	PRINT_STM			11			/* Print statement */
#define	TERM_STM			12			/* Terminator statement */
#define	EXPT_STM			13			/* Export statement */
#define	TX_STM				14			/* Transaction statement */
#define	ARRAY_STM			15			/* Array statement */
/*
**	Special file names
*/
#define	LOGINPARMS			@"SF_StepForwardParms"
#define	DEFAULTS			@"SF_Defaults"
#define	ADMINISTRATOR		@"Administrator"
#define	CLIENTPATH			@"CLIENTPATH"
/*
**	Reasons for non-editability of Account Prototype
*/
#define	DATA_EXISTS	  0			/* Data already exists in Master */
#define	LINKED_FIELD	  1			/* SF_SubledgerNumber is linked field */
/*
**	Text divider for Services pasteboard
*/
#define	TEXTDIVIDER		255			/* Non-printable character */
#define	STRINGDIVIDER	@"@"		/* Divider character */
/*
**	Action type constants
*/
#define	ASK_TYPE				@"Ask"		/* Ask action type */
#define	SUGGEST_TYPE			@"Suggest"	/* Suggest action type */
#define	REPEAT_TYPE			@"Repeat"	/* Repeat action type */
#define	SKIP_TYPE				@"Skip"		/* Skip (no edit) action type */
#define	LOCK_TYPE				@"Lock"		/* Lock action type */
#define	ASK						    0			/* Ask action code */
#define	SUGGEST				    1			/* Suggest action code */
#define	REPEAT					    2			/* Repeat action code */
#define	SKIP						    3			/* Skip (no edit) action code */
#define	LOCK					    4			/* Lock action code */
#define	DISPLAY_AND_TRIGGER		254		/* Display and Trigger (procedure) code */
#define	DISPLAY_ONLY				255		/* Display only code */
/*
**	Security access mask tags
*/
#define	NO_ACCESS				0			/* No access */
#define	READ_ONLY				1			/* Read only access */
#define	READ_WRITE				2			/* Read and write access */
#define	UNKNOWN_ACCESS		255			/* Unknown access */
/*
**	Signal string for Fiscal Periods reloading
*/
#define	LOADFPTABLE	@"RFP"			/* Reload Fiscal Period table */
/*
**	Open Item constants
*/
#define	UNMATCHED		@"UNMATCHED"
#define	OPEN_GROUPS		0				/* Show open groups only */
#define	ALL_GROUPS			1				/* Show all groups*/
/*
**	Gray color tags
*/
#define	WHITE_COLOR			0
#define	LIGHT_GRAY_COLOR		1
#define	DARK_GRAY_COLOR		2
#define	BLACK_COLOR			3
#define	BACKGROUND_COLOR		4
/*
**	Database table names
*/
#define	ACCTSTRUCT		@"SF_SYSAccountStructure"	         /* GL Account Structure table */
#define	ACCTRANGET	@"SF_SYSAccountRanges"	         /* GL Account Range list table */
#define	ACCTRANGEN	@"SF_SYSAccountRangeNames" /* GL Account Range name table */
#define	ACCTRANGES	@"SF_SYSVAccountRanges"         /* GL Account Range list view */
#define	ACCTGROUPT	@"SF_SYSAccountGroups"             /* GL Account Group list table */
#define	ACCTGROUPN	@"SF_SYSAccountGroupNames"  /* GL Account Group name table */
#define	ACCTGROUPS	@"SF_SYSVAccountGroups"          /* GL Account Group list view */
#define	LISTACCOUNT	@"SF_SYSVListAccount"	         /* GL Account Code view */
#define	GLACCOUNT		@"SF_SYSGLAccount"		         /* GL Accounts table */
#define	VALIDACCOUNT	@"SF_SYSVGLAccount"	         /* View of GL Accounts table */
#define	ACCOUNTNAME	@"SF_SYSAccountName"	         /* View to show GL# and Descr */
#define	FISCALPERIOD	@"SF_SYSFiscalPeriods"	         /* Fiscal Periods table */
#define	SYSTEMSTATE	@"SF_SYSSystemState"		         /* System State table */
#define	TXFIELDS		@"SF_SYSTXInputFields"	         /* Transaction Fields table */
#define	TXTEMPLFIELDS	@"SF_SYSTXTemplateFields"        /* Template field catalog table */
#define	LEVELHEADER	@"SF_SYSLevelHeader"	         /* GL Account Level Header table */
#define	TXTMPLDETAIL	@"SF_SYSTransactionFields"         /* TX Template Detail table */
#define	MASTERLOG		@"SF_SYSMasterLog"		         /* TX Log table */
#define	SETUP			@"SF_SYSSetup"			         /* System Setup table */
#define	TEMPLATES		@"SF_SYSTemplates"		         /* TX/Master Template table */
#define	PROCEDURES	@"SF_SYSProcedures"		         /* Procedures table */
#define	SOURCEDOC		@"SF_SYSSourceDocument"	         /* Source Documents table */
#define	SPECIALGL		@"SF_SYSSpecialGL"		         /* Special GL Accounts table */
#define	DOCTRIGGER		@"SF_SYSDocumentTrigger"	         /* Document Trigger table */
#define	STDVALUES	 	@"SF_SYSStandardValues"	         /* Standard Values table */
#define	TRANSACTION	@"SF_TXVTransaction"		         /* Transaction Detail view */
#define	TXDETAIL		@"SF_TXDetail"			         /* Transaction Detail table */
#define	TXSUMMARY		@"SF_TXSummary"		         /* Transaction Summary table */
#define	TXVSUMMARY	@"SF_TXVSummary"		         /* Transaction Summary view */
#define	TXNUMBER		@"SF_TXNumber"			         /* Transaction Number table */
#define	OPNTEMTBL		@"SF_SYSOpenItems"		         /* Open Items table */
#define	OPENITEM		@"SF_SYSVOpenItems"		         /* View of the Open Items table */
#define	BUNDLE			@"SF_SYSBundle"			         /* Suggested Distribution table */
#define	USERFUNCTIONS	@"SF_SYSUserFunctions"	         /* User-defined Functions table */
#define	FLOWCHARTS	@"FLOWCHARTS"			         /* Report Flow Charts table */
#define	SAVEDREPORTS	@"SAVEDREPORTS"		         /* Saved Reports table */
#define	PRTEMPLATES	@"PRTEMPLATES"			         /* Print Templates table */
#define	ACCESSRIGHTS	@"SF_SYSDataAccess"		         /* Access mask table */
#define	MASTERFIELDS	@"SF_SYSMasterInputFields"         /* General field catalog table */
#define	MSTEMPLFIELDS	@"SF_SYSMasterTemplateFields" /* Template field catalog table */
#define	SRCHCRITTABLE	@"SF_SYSSearchCriteria"	         /* Archived search criteria table */
#define	PROCINTEGRITY	@"PROCINTEGRITY"		         /* Procedure dependency table */
#define	ACCESSTABLE	@"SF_SYSSecurity"		         /* Field security table */
#define	CHEQUETABLE	@"SF_SYSChequeNumber"	         /* Last used cheque number table */
#define	PROCESSES		@"SF_SYSProcess"		         /* Processes table */
#define	SCHEDULES		@"SCHEDULES"			         /* Schedules table */
/*
**	Master Database names
*/
#define	USERTABLE	  	@"Users"					/* Users id's and passwords */
#define	CLIENTTABLE		@"Clients"				/* Client names */
#define	PATHTABLE		@"Executables"			/* Names of executable files */
#define	MASTERDB		@"SF_Master"				/* Master database */
#define	DATEFORMATS	@"SF_SYSDateFormats"	/* Date Formats table */
/*
**	Common Transaction template name and other literals
*/
#define	COMM			@"Common"			/* Common template */
#define	TXRESOURCE		@"TXDetail"			/* TXDetail DB source */
#define	OPIRESOURCE	@"OpenItem"			/* OpenItem DB source */
#define	SYSSTATE		@"SysState"			/* SysState DB source */
#define	ACCTNAME		@"AcctName"			/* AcctName DB source */
#define	ACCGROUP		@"AccGroup"			/* AccGroup DB source */
#define	ACCLIST			@"AccList"			/* AccList DB source */
#define	GENERAL_LIST	@"General list"		/* "General list" option */
#define	UNTITLED		@"UNTITLED"			/* "UNTITLED" option */
#define	APPLICATION		@"APPLICATION"		/* Name of the application */
#define	MAINSERVER		@"MAINSERVER"		/* Main server */
#define	BATCHREPORT	@"BatchReport"		/* Tag of the background report */
#define	BATCHPROCESS	@"BatchProcess"		/* Tag of the background process */
#define	AUTOMATIC		@"Automatic"			/* Tag of the scheduled process */
#define	MANUAL			@"Manual"			/* Tag of the manually submitted process */

/*
**	Print Field types
*/
#define	NEWPAGEFLAG		-1		/* New page flag */
#define	STATIC				0		/* Static field */
#define	DYNAMIC			1		/* Dynamic field */
#define	DBMASTER			2		/* DB Master field */
#define	SGMDIVIDER			3		/* Segment divider */
#define	USTATIC				4		/* Underline field */
#define	PAGE				5		/* Page field */
#define	CURRENTDATE		6		/* Current date */
#define	CURRENTTIME		7		/* Current time */

/*
**	Formatting view types
*/
#define	DATE_FORMATS		0		/* DateFormatView */
#define	TIME_FORMATS		1		/* TimeFormatView */
#define	INT_FORMATS		2		/* IntegerFormatView */
#define	FLOAT_FORMATS		3		/* FloatFormatView */
#define	MONEY_FORMATS	4		/* MoneyFormatView */
#define	TEXT_FORMATS		5		/* TextFormatView */
#define	SWITCH_FORMATS	6		/* SwitchFormatView */
#define	IMAGE_FORMATS		7		/* ImageFormatView */
#define	NO_FORMATS		8		/* NoFormatView */

/*
**	Negative values formatting styles
*/
#define	MINUS_LEFT			0		/* -123 */
#define	MINUS_NONE			1		/* (123) */
#define	MINUS_RIGHT			2		/* 123- */

/*
**	Sign printing styles
*/
#define	SIGN_KEEP			0		/* Keep sign as is */
#define	SIGN_REVERSE		1		/* Reverse to opposite */
#define	SIGN_IGNORE			2		/* Never print minus */

/*
**	Money amount printing styles
*/
#define	PLAIN_NUMBER			0	/* Print as plain number */
#define	COMMA_SEPARATED		1	/* Separate 000's by commas */
#define	TEXT_STRING				2	/* Print as text string */

/*
**	Money amount capitalization styles
*/
#define	CAPITALIZE_ALL			0	/* Capitalize all letters */
#define	CAPITALIZE_FIRST		1	/* Capitalize first letter */
#define	CAPITALIZE_NONE		2	/* Do not capitalize letters */

/*
**	Inspector main pop-up list codes
*/
#define	TMPL_VIEW		@"Template"		/* Option 1 of PopUpList ("Template") */
#define	SGM_VIEW		@"Segment"		/* Option 2 of PopUpList ("Segment") */
#define	FLD_VIEW		@"Field"			/* Option 3 of PopUpList ("Field") */

/*
**	Segment types
*/
#define	HEADER_START		0		/* Print when Template starts */
#define	HEADER_PAGE		1		/* Print after new page begins */
#define	HEADER_BOTH		5		/* Print in both cases */
#define	BODY				2		/* Print on every call to Template */
#define	FOOTER_PAGE		3		/* Print before new page begins */
#define	FOOTER_END		4		/* Print when Template ends */
#define	FOOTER_BOTH		6		/* Print in both cases */

/*
**	Underline types
*/
#define	SINGLE_LINE			0		/* Single underline */
#define	DOUBLE_LINE		1		/* Double underline */

/*
**	Printing types
*/
#define	START_PAGE			0		/* Always start on the new page */
#define	START_LINE			1		/* Start on the next available line */

/*
**	Master types
*/
#define	MASTER_UNKNOWN		-1		/* Master not defined */
#define	TXMASTER				0		/* Transaction master */
#define	GBMASTER				1		/* Global master */
#define	SLMASTER				2		/* Subledger master */
#define	SYSMASTER				3		/* System State table */
#define	ACCTNAMEMASTER		4		/* Account Name table */
#define	ACCTGROUPMASTER		5		/* Account Group table */
#define	EXMASTER				6		/* Extra table */
#define	TEMPMASTER			7		/* Temporary table */
#define	FORMASTER				8		/* Foreign table */
#define	ACCTLISTMASTER			9		/* Account List table */

/*
**	Search element types
*/
#define	DATA					    0		/* Element contains the Field */
#define	DIVIDER				   	 1		/* Element contains the Divider */
#define	HIDDEN				  	  2		/* Element contains SL Master */

/*
**	I/O flags
*/
#define	INPUT					    0		/* Input flag */
#define	OUTPUT					    1		/* Output flag */

/*
**	Type operation codes
*/
#define	TEXT_ACTION		0		/* Set type to TEXT */
#define	DATE_ACTION		1		/* Set type to DATE */
#define	MONEY_ACTION		2		/* Set type to MONEY */
#define	INTEGER_ACTION		3		/* Set type to INTEGER */
#define	FLOAT_ACTION		4		/* Set type to FLOAT */
#define	GLPFX_ACTION		5		/* Set type to GL Prefix */
#define	GLNUM_ACTION		6		/* Set type to GL Number */
#define	GLLIST_ACTION		7		/* Set type to GL Number */
#define	PERIOD_ACTION		8		/* Set type to Fiscal period */

/*
**	DatabaseUpdateStatement operation codes
*/
#define	SET_ACTION			0		/* "Set" field to new value */
#define	ADD_ACTION			1		/* "Add" value to the field */
#define	SUB_ACTION			2		/* "Subtract" value from the field */

/*
**	Inspector aggregate function codes
*/
#define	NOAGGR				-1		/* None (no aggregate function) */
#define	SUMAGGR			0		/* Summation over the column */
#define	MAXAGGR			1		/* Maximum value in the column */
#define	MINAGGR			2		/* Minimum value in the column */
#define	AVGAGGR			3		/* Averaging over the column */

/*
**	Palette main pop-up list codes
*/
#define	MAIN_VIEW		@"Main resources"
#define	FNCT_VIEW		@"Functions"
#define	ACCT_VIEW		@"Accounts"
#define	GROUP_VIEW		@"Groups"
#define	ACLIST_VIEW		@"Lists"

/*
**	Template palette main pop-up list codes
*/
#define	FIELDS_VIEW		@"Display fields"
#define	PRTMPLT_VIEW	@"Print templates"
#define	LOGO_VIEW		@"Logo"

/*
**	Export file format pop-up list titles
*/
#define	ASCII_BLANK		@"ASCII, blank-delimited"
#define	ASCII_COMMA	@"ASCII, comma-delimited"

/*
**	Export file format pop-up list codes
*/
#define	ASCII_BLANK_CODE			0		/* ASCII, blank-delimited */
#define	ASCII_COMMA_CODE			1		/* ASCII, comma-delimited */

/*
**	Export file naming codes
*/
#define	ASK_AT_RUNTIME				   0		/* Ask for file name at run time */
#define	SET_NOW					   1		/* Set name at construction time */

/*
**	Inspector query row processing codes
*/
#define	SINGLE_ROW					0		/* Query returns single row */
#define	MULTIPLE_ROWS_ALL			1		/* Query returns all multiple rows */
#define	MULTIPLE_ROWS_DISTINCT		2		/* Query returns distinct multiple rows */

/*
**	Inspector array row processing codes
*/
#define	ARRAY_IN					0		/* Tag for "Array In" graphic */
#define	ARRAY_OUT					1		/* Tag for "Array Out" graphic */

/*
**	GrabIconCell tags
*/
#define	TITLE_FIELD					   0		/* Title cell */
#define	BOX_FIELD				 	   1		/* Box cell */

/*
**	Rhombus exit orientation flags
*/
#define	YES_AT_LEFT				    0		/* YES at left exit */
#define	YES_AT_RIGHT				    1		/* YES at right exit */

/*
**	System Variable (SYSVAR) names
*/
#define	CHEQUE_NO			@"CHEQUE_#"
#define	PAY_TO				@"PAY_TO"
#define	ORIGINAL_AMT		@"ORIGINAL_AMOUNT"
#define	PAYMENT_AMT		@"PAYMENT_AMOUNT"
#define	CURDATENAME		@"CURRENTDATE"
#define	CURTIMENAME		@"CURRENTTIME"
#define	CURMASTER			@"CURRENTMASTER"
#define	CNTLGLPREFIX		@"CNTRL_GL_PREFIX"
#define	CNTLGLNUMBER		@"CNTRL_GL_NUMBER"
#define	NEW_RCRD_FLAG		@"NEW_RECORD"

/*
**	Schedule constants
*/
#define	SUNDAY_SCHD			0
#define	MONDAY_SCHD			1
#define	TUESDAY_SCHD			2
#define	WEDNESDAY_SCHD		3
#define	THURSDAY_SCHD			4
#define	FRIDAY_SCHD			5
#define	SATURDAY_SCHD			6

#define	MONTHLY_SCHD			0
#define	WEEKLY_SCHD			1
#define	DAILY_SCHD				2
#define	HOURLY_SCHD			3
#define	MINUTELY_SCHD			4

#define	LAST_DAY			   255

/*
**	Function prototypes
*/
void grid(float width, float height, float gap, float color);
void drawLine(int x1, int y1, int x2, int y2);
void drawArrow(int tail_x, int tail_y, int tip_x, int tip_y);
NSString *incrementString(NSString *source);
NSString *decrementString(NSString *source);
void reconnectObjectsInList (id graphicList);
BOOL isTokenInString(NSString *string, NSString *word, unichar divider);
int operationDataType(int type1, int type2, int operation);
BOOL isPreviousWord(NSString *string, int offset, NSString *word);
NSString *asciiDataType(int type);
NSString *asciiDataTypeExtended(int type);
NSString *asciiTriggerType(char type);
char *asciiOperator(int operator);
NSString *asciiAggregate(int type);
int intDataType(NSString *string);
NSString *charDataType(int type);
NSString *wrappedString (SFDataWrapper *dataWrapper, SFQuestion *question);
NSString *wrappedData (SFDataWrapper *dataWrapper, int precision, int length);
NSString *searchOperator(int type);
NSString *characterValue(void *data, int type, int size, int precision);
BOOL integerWithinRange(NSString *string, int size);
NSString *fieldName(NSString *string);
void SFSetUserName (NSString *name);
NSString *SFUserName (void);
BOOL isEmptyString (NSString *string);
NSEvent *periodicEvent (NSEvent *oldEvent, NSPoint point);
NSRect SFDrawTiledRects(NSRect boundsRect, NSRect clipRect, const NSRectEdge *sides,
	const float *grays, int count);
