#import <Foundation/NSObject.h>
#import <SFVariable.h>

@interface SFSystemFunction : NSObject
/*
**	An abstract superclass that implements the basic functionality
**	of all System functions.
*/
{
	id delegate;				/* Delegate to get DB channel from */
	id database;				/* Database channel */
	id parameterList;			/* Storage of PARAMETERDATA structures */
	SFVariable *returnVariable;	/* Variable to hold returned value */
	BOOL isPrefixUsed;			/* Whether GL Prefix is used */
}

+ (void) freeAllFunctions;
- initFor: (id) sender;
- (void) setPane: (id) object;
- (void) setFunctionName: (NSString *) name;
- (int) returnType;
- (NSMutableArray *) parameterList;
- (NSString *) descriptionForFunction: (NSString *) name;
- (NSString *) functionName;
- execute: (NSArray *) parmList;
- (BOOL) caresForPrefixStatus;
- (void) setPrefixStatus;
- (void) wrapUp;
- (void) dealloc;

@end